unit Service;
{$MODE ObjFpc}
{$H+}
{$INTERFACES CORBA}

interface

uses
  Classes, SysUtils;

type
  IListener = interface
    procedure Step;
    procedure AddLogline(Line: String);
  end;

  TMyService = class(TObject)
    private
      FListener: IListener;
    public
      property Listener: IListener read FListener write FListener;
    public
      procedure DoSomething;
  end;

implementation

procedure TMyService.DoSomething;
var
  i: Integer;
begin
  for i := 0 to 200 do begin
    Sleep(100);
    FListener.AddLogline('We are in cycle #' + IntToStr(i));
    FListener.Step;
  end;
end;

end.
