unit fmain;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ComCtrls, service;

type

  { TForm1 }

  TForm1 = class(TForm, IListener)
    Button1: TButton;
    Memo1: TMemo;
    ProgressBar1: TProgressBar;
    procedure Button1Click(Sender: TObject);
  private

  public
    procedure Step;
    procedure AddLogline(Line: String);
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}
procedure TForm1.Button1Click(Sender: TObject);
var
  MyService: TMyService;
begin
  try
    MyService := TMyService.Create;
    MyService.Listener := Self;
    MyService.DoSomething;
  finally
    FreeAndNil(MyService);
  end;
end;

procedure TForm1.Step;
begin
  ProgressBar1.StepIt;
  Application.ProcessMessages;
end;

procedure TForm1.AddLogline(Line: String);
begin
  Memo1.Append(Line);
  Application.ProcessMessages;
end;

end.

